﻿BieChuDB = BieChuDB or {}
BieChuDB.SmallIcon = BieChuDB.SmallIcon or {
	enable = true,
}
if not BieChuDB.SmallIcon.enable then return end

local CREATURE_TYPE_ICON = {
	['畸变怪'] = 'Interface\\Icons\\spell_shadow_antishadow',
	['野兽'] = 'Interface\\Icons\\Ability_Racial_BearForm',
	['小动物'] = 'Interface\\Icons\\ABILITY_SEAL',
	['恶魔'] = 'Interface\\Icons\\Spell_Shadow_Metamorphosis',
	['龙类'] = 'Interface\\Icons\\INV_Misc_Head_Dragon_01',
	['元素生物'] = 'Interface\\Icons\\Spell_Frost_SummonWaterElemental',
	['巨人'] = 'Interface\\Icons\\Ability_Racial_Avatar',
	['气体云雾'] = 'Interface\\Icons\\INV_Elemental_Mote_Air01',
	['人型生物'] = 'Interface\\Icons\\Spell_Holy_PrayerOfHealing',
	['机械'] = 'Interface\\Icons\\INV_Gizmo_02',
	['非战斗宠物'] = 'Interface\\Icons\\Spell_Nature_Polymorph',
	['未指定'] = 'Interface\\Icons\\INV_Misc_QuestionMark',
	['图腾'] = 'Interface\\Icons\\Spell_Nature_NatureResistanceTotem',
	['亡灵'] = 'Interface\\Icons\\Spell_Shadow_RaiseDead',
	['Unknown'] = 'Interface\\Icons\\INV_Misc_QuestionMark',
}

local frame = CreateFrame('Frame')
function frame:create(parent, unit)
	if frame[unit] then return end
	local button = CreateFrame('Button', 'frame_' .. parent:GetName() ..'Icon', parent)
	button:SetSize(32, 32)
	button:SetPoint('TOPLEFT', 110, 3)
	button:SetHighlightTexture('Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight')
	button.Border = button:CreateTexture(nil, 'OVERLAY')
	button.Border:SetTexture('Interface\\Minimap\\MiniMap-TrackingBorder')
	button.Border:SetSize(54, 54)
	button.Border:SetPoint('CENTER', 11, -12)
	button.Icon = button:CreateTexture(nil, 'ARTWORK')
	button.Icon:SetWidth(20)
	button.Icon:SetHeight(20)
	button.Icon:SetPoint('CENTER')
	button:SetScript('OnMouseDown', function(self, button) -- 目标职业图标扩展：按住Shift复制名字 左键观察/右键跟随/中键密语
		if IsShiftKeyDown() then
			local name, server = UnitName(unit)
			if server and server ~= '' then name = name .. '-' .. server end
			local editbox = ChatEdit_ChooseBoxForSend()
			if not editbox:IsShown() then ChatEdit_ActivateChat(editbox) end
			editbox:SetText(name)
			editbox:HighlightText()
		else
			if UnitIsFriend('player', unit) and UnitIsPlayer(unit) then
				if button == 'LeftButton' then
					if CheckInteractDistance(unit, 1) then InspectUnit(unit) end -- 观察
				elseif button == 'RightButton' then
					if CheckInteractDistance(unit, 4) then FollowUnit(unit) end -- 跟随
				elseif button == 'MiddleButton' then
					local name, server = UnitName(unit)
					if server then name = name .. '-' .. server end
					ChatFrame_SendTell(name) -- 密语
				end
			end
		end
	end)
	frame[unit] = button
end

function frame:update(unit)
	if not frame[unit] then return end
	if UnitIsPlayer(unit) then
		local coord = CLASS_ICON_TCOORDS[select(2, UnitClass(unit))]
		frame[unit].Icon:SetTexture('Interface\\TargetingFrame\\UI-Classes-Circles')
		frame[unit].Icon:SetTexCoord(coord[1], coord[2], coord[3], coord[4])
		frame[unit]:Show()
	else
		local creature = UnitCreatureType(unit)
		if creature and CREATURE_TYPE_ICON[creature] then
			frame[unit].Icon:SetTexture(CREATURE_TYPE_ICON[creature])
			frame[unit].Icon:SetTexCoord(0, 1, 0, 1)
			frame[unit]:Show()
		else
			frame[unit]:Hide()
		end
	end
end

hooksecurefunc('UnitFrame_OnEvent', function(self, event)
	if event == 'UNIT_PORTRAIT_UPDATE' then frame:update(self.unit) end
end)
hooksecurefunc('UnitFrame_Update', function(self)
	frame:update(self.unit)
end)

frame:RegisterEvent('PLAYER_ENTERING_WORLD')
frame:SetScript('OnEvent', function(self)
	self:create(TargetFrame, 'target')
	self:create(FocusFrame, 'focus')
end)
